Index: pjproject/trunk/pjlib/build/pjlib.dsp
===================================================================
--- pjproject/trunk/pjlib/build/pjlib.dsp	(revision 124)
+++ pjproject/trunk/pjlib/build/pjlib.dsp	(revision 125)
@@ -165,4 +165,13 @@
 # End Source File
 # End Group
+# Begin Group "src_compat"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pj\compat\unicode_win32.c
+# PROP Exclude_From_Build 1
+# End Source File
+# End Group
 # Begin Source File
 
@@ -426,4 +435,8 @@
 
 SOURCE=..\include\pj\compat\time.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pj\compat\unicode.h
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjlib/build/pjlib.vcproj
===================================================================
--- pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 124)
+++ pjproject/trunk/pjlib/build/pjlib.vcproj	(revision 125)
@@ -5,5 +5,7 @@
 	Name="pjlib"
 	SccProjectName="&quot;$/pjproject/pjlib/build&quot;, UIAAAAAA"
-	SccLocalPath=".">
+	SccAuxPath=""
+	SccLocalPath="."
+	SccProvider="MSSCCI:Microsoft Visual SourceSafe">
 	<Platforms>
 		<Platform
@@ -1309,4 +1311,23 @@
 				</File>
 			</Filter>
+			<Filter
+				Name="Src Compat"
+				Filter="">
+				<File
+					RelativePath="..\src\pj\compat\unicode_win32.c">
+					<FileConfiguration
+						Name="Debug|Win32"
+						ExcludedFromBuild="TRUE">
+						<Tool
+							Name="VCCLCompilerTool"/>
+					</FileConfiguration>
+					<FileConfiguration
+						Name="Release|Win32"
+						ExcludedFromBuild="TRUE">
+						<Tool
+							Name="VCCLCompilerTool"/>
+					</FileConfiguration>
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
@@ -1477,4 +1498,7 @@
 				<File
 					RelativePath="..\include\pj\compat\time.h">
+				</File>
+				<File
+					RelativePath="..\include\pj\compat\unicode.h">
 				</File>
 				<File
Index: pjproject/trunk/pjlib/include/pj/compat/errno.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/errno.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/errno.h	(revision 125)
@@ -20,5 +20,6 @@
 #define __PJ_COMPAT_ERRNO_H__
 
-#if defined(PJ_WIN32) && PJ_WIN32 != 0
+#if defined(PJ_WIN32) && PJ_WIN32 != 0 || \
+    defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE != 0
 
     typedef unsigned long pj_os_err_type;
Index: pjproject/trunk/pjlib/include/pj/compat/m_arm.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/m_arm.h	(revision 125)
+++ pjproject/trunk/pjlib/include/pj/compat/m_arm.h	(revision 125)
@@ -0,0 +1,38 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJ_COMPAT_M_ARM_H__
+#define __PJ_COMPAT_M_ARM_H__
+
+/**
+ * @file m_arm.h
+ * @brief Describes ARM family processor specifics.
+ */
+
+/*
+ * This file covers PJ_M_ARMV4 etc.
+ */
+
+#define PJ_M_NAME		"ARM"
+
+#define PJ_HAS_PENTIUM		0
+#define PJ_IS_LITTLE_ENDIAN	1
+#define PJ_IS_BIG_ENDIAN	0
+
+
+#endif	/* __PJ_COMPAT_M_ARM_H__ */
Index: pjproject/trunk/pjlib/include/pj/compat/os_linux.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_linux.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/os_linux.h	(revision 125)
@@ -78,4 +78,5 @@
 #define PJ_HAS_MALLOC               1
 #define PJ_OS_HAS_CHECK_STACK	    0
+#define PJ_NATIVE_STRING_IS_UNICODE 0
 
 #define PJ_ATOMIC_VALUE_TYPE	    long
Index: pjproject/trunk/pjlib/include/pj/compat/os_linux_kernel.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_linux_kernel.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/os_linux_kernel.h	(revision 125)
@@ -97,4 +97,5 @@
 #define PJ_OS_HAS_CHECK_STACK	    0
 #define PJ_TERM_HAS_COLOR	    0
+#define PJ_NATIVE_STRING_IS_UNICODE 0
 
 #define PJ_ATOMIC_VALUE_TYPE	    int
Index: pjproject/trunk/pjlib/include/pj/compat/os_palmos.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_palmos.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/os_palmos.h	(revision 125)
@@ -76,4 +76,5 @@
 #define PJ_HAS_HIGH_RES_TIMER	    1
 #define PJ_OS_HAS_CHECK_STACK	    0
+#define PJ_NATIVE_STRING_IS_UNICODE 0
 
 #endif	/* __PJ_COMPAT_OS_PALMOS_H__ */
Index: pjproject/trunk/pjlib/include/pj/compat/os_sunos.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_sunos.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/os_sunos.h	(revision 125)
@@ -78,4 +78,5 @@
 #define PJ_HAS_MALLOC               1
 #define PJ_OS_HAS_CHECK_STACK	    0
+#define PJ_NATIVE_STRING_IS_UNICODE 0
 
 #define PJ_ATOMIC_VALUE_TYPE	    long
Index: pjproject/trunk/pjlib/include/pj/compat/os_win32.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_win32.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/os_win32.h	(revision 125)
@@ -82,4 +82,5 @@
 #define PJ_HAS_MALLOC               1
 #define PJ_OS_HAS_CHECK_STACK	    1
+#define PJ_NATIVE_STRING_IS_UNICODE 0
 
 #define PJ_ATOMIC_VALUE_TYPE	    long
Index: pjproject/trunk/pjlib/include/pj/compat/os_win32_wince.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_win32_wince.h	(revision 125)
+++ pjproject/trunk/pjlib/include/pj/compat/os_win32_wince.h	(revision 125)
@@ -0,0 +1,99 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJ_COMPAT_OS_WIN32_WINCE_H__
+#define __PJ_COMPAT_OS_WIN32_WINCE_H__
+
+/**
+ * @file os_win32.h
+ * @brief Describes Win32 operating system family specifics.
+ */
+
+#define PJ_OS_NAME		    "win32-wince"
+
+#define WIN32_LEAN_AND_MEAN
+//#define PJ_WIN32_WINNT		    0x0400
+//#define _WIN32_WINNT		    PJ_WIN32_WINNT
+
+#define PJ_HAS_ARPA_INET_H	    0
+#define PJ_HAS_ASSERT_H		    1
+#define PJ_HAS_CTYPE_H		    1
+#define PJ_HAS_ERRNO_H		    0   /* Must be zero, otherwise errno_test() fails. */
+#define PJ_HAS_LINUX_SOCKET_H	    0
+#define PJ_HAS_MALLOC_H		    1
+#define PJ_HAS_NETDB_H		    0
+#define PJ_HAS_NETINET_IN_H	    0
+#define PJ_HAS_SETJMP_H		    1
+#define PJ_HAS_STDARG_H		    1
+#define PJ_HAS_STDDEF_H		    1
+#define PJ_HAS_STDIO_H		    1
+#define PJ_HAS_STDLIB_H		    1
+#define PJ_HAS_STRING_H		    1
+#define PJ_HAS_SYS_IOCTL_H	    0
+#define PJ_HAS_SYS_SELECT_H	    0
+#define PJ_HAS_SYS_SOCKET_H	    0
+#define PJ_HAS_SYS_TIMEB_H	    0	/* Doesn't have sys/timeb.h */
+#define PJ_HAS_SYS_TYPES_H	    0	/* Doesn't have sys/types.h */
+#define PJ_HAS_TIME_H		    1
+#define PJ_HAS_UNISTD_H		    0
+
+#define PJ_HAS_MSWSOCK_H	    1
+#define PJ_HAS_WINSOCK_H	    0
+#define PJ_HAS_WINSOCK2_H	    1
+
+#define PJ_SOCK_HAS_INET_ATON	    0
+
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() or send() can not return immediately.
+ */
+#define PJ_BLOCKING_ERROR_VAL       WSAEWOULDBLOCK
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   WSAEWOULDBLOCK
+
+/* Default threading is enabled, unless it's overridden. */
+#ifndef PJ_HAS_THREADS
+#  define PJ_HAS_THREADS	    (1)
+#endif
+
+#define PJ_HAS_HIGH_RES_TIMER	    1
+#define PJ_HAS_MALLOC               1
+#define PJ_OS_HAS_CHECK_STACK	    1
+
+#define PJ_ATOMIC_VALUE_TYPE	    long
+
+/* TlsAlloc() error value. */
+#define TLS_OUT_OF_INDEXES	    0xFFFFFFFF 
+
+/* No console. */
+#define PJ_TERM_HAS_COLOR	    0
+
+/* No rdtsc */
+#define PJ_TIMESTAMP_USE_RDTSC	    0
+
+/* Native string is Unicode. */
+#define PJ_NATIVE_STRING_IS_UNICODE 1
+
+#endif	/* __PJ_COMPAT_OS_WIN32_WINCE_H__ */
Index: pjproject/trunk/pjlib/include/pj/compat/socket.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/socket.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/socket.h	(revision 125)
@@ -96,5 +96,5 @@
  * Linux kernel specifics
  */
-#ifdef PJ_LINUX_KERNEL
+#if defined(PJ_LINUX_KERNEL)
 #   include <linux/net.h>
 #   include <asm/ioctls.h>		/* FIONBIO	*/
@@ -124,6 +124,6 @@
  * Windows specific
  */
-#ifdef PJ_WIN32
-    typedef int socklen_t;;
+#if defined(PJ_WIN32) || defined(PJ_WIN32_WINCE)
+    typedef int socklen_t;
 #endif
 
Index: pjproject/trunk/pjlib/include/pj/compat/string.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/string.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/compat/string.h	(revision 125)
@@ -36,5 +36,9 @@
 #if defined(_MSC_VER)
 #  define strcasecmp	stricmp
-#  define strncasecmp	strnicmp
+#  if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
+#   define strncasecmp	_strnicmp
+#  else
+#   define strncasecmp	strnicmp
+#  endif
 #  define snprintf	_snprintf
 #else
Index: pjproject/trunk/pjlib/include/pj/compat/unicode.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/unicode.h	(revision 125)
+++ pjproject/trunk/pjlib/include/pj/compat/unicode.h	(revision 125)
@@ -0,0 +1,45 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJ_COMPAT_UNICODE_H__
+#define __PJ_COMPAT_UNICODE_H__
+
+#include <pj/types.h>
+
+/**
+ * @file unicode.h
+ * @brief Provides Unicode conversion for Unicode OSes
+ */
+
+#if defined(PJ_NATIVE_STRING_IS_UNICODE) && PJ_NATIVE_STRING_IS_UNICODE!=0
+
+#   define PJ_DECL_UNICODE_TEMP_BUF(var,size)    wchar_t var[size]
+#   define PJ_NATIVE_STRING(s,buf) pj_ansi_to_unicode(s,buf,PJ_ARRAY_SIZE(buf))
+
+    PJ_DECL(wchar_t*) pj_ansi_to_unicode(const char *s, wchar_t *buf,
+					 pj_size_t buf_count);
+
+#else	/* PJ_NATIVE_STRING_IS_UNICODE */
+
+#   define PJ_DECL_UNICODE_TEMP_BUF(var,size)
+#   define PJ_NATIVE_STRING(s, buf)		s
+
+#endif	/* PJ_NATIVE_STRING_IS_UNICODE */
+
+
+#endif	/* __PJ_COMPAT_UNICODE_H__ */
Index: pjproject/trunk/pjlib/include/pj/config.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/config.h	(revision 125)
@@ -42,4 +42,6 @@
 #if defined(PJ_WIN32) && PJ_WIN32!=0
 #  include <pj/compat/os_win32.h>
+#elif defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
+#  include <pj/compat/os_win32_wince.h>
 #elif defined(PJ_LINUX) && PJ_LINUX!=0
 #  include <pj/compat/os_linux.h>
@@ -66,4 +68,6 @@
 #elif defined (PJ_M_SPARC) && PJ_M_SPARC != 0
 #   include <pj/compat/m_sparc.h>
+#elif defined (PJ_M_ARMV4) && PJ_M_ARMV4 != 0
+#   include <pj/compat/m_arm.h>
 #else
 #  error "Please specify target machine."
Index: pjproject/trunk/pjlib/include/pj/log.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/log.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/log.h	(revision 125)
@@ -78,4 +78,5 @@
     PJ_LOG_HAS_SENDER	  =  64, /**< Include sender in the log [yes].	     */
     PJ_LOG_HAS_NEWLINE	  = 128, /**< Terminate each call with newline [yes].*/
+    PJ_LOG_HAS_CR	  = 256, /**< Include carriage return [no].	     */
 };
 
Index: pjproject/trunk/pjlib/include/pj/types.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/types.h	(revision 124)
+++ pjproject/trunk/pjlib/include/pj/types.h	(revision 125)
@@ -387,8 +387,8 @@
     int wday;
 
-    /** This represents day of the year, 0-365, where zero means
+    /* This represents day of the year, 0-365, where zero means
      *  1st of January.
      */
-    int yday;
+    /*int yday; */
 
     /** This represents day of month: 1-31 */
Index: pjproject/trunk/pjlib/src/pj/compat/unicode_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/compat/unicode_win32.c	(revision 125)
+++ pjproject/trunk/pjlib/src/pj/compat/unicode_win32.c	(revision 125)
@@ -0,0 +1,38 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/compat/unicode.h>
+#include <pj/assert.h>
+#include <pj/string.h>
+#include <windows.h>
+
+
+PJ_DEF(wchar_t*) pj_ansi_to_unicode(const char *s, wchar_t *buf,
+				    pj_size_t buf_count)
+{
+    int len;
+
+    PJ_ASSERT_RETURN(s, NULL);
+
+    len = MultiByteToWideChar(CP_ACP, 0, s, strlen(s), 
+			      buf, buf_count);
+    if (!len)
+	return NULL;
+
+    return buf;
+}
Index: pjproject/trunk/pjlib/src/pj/file_access_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/file_access_win32.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/file_access_win32.c	(revision 125)
@@ -18,6 +18,9 @@
  */
 #include <pj/file_access.h>
+#include <pj/compat/unicode.h>
 #include <pj/assert.h>
 #include <pj/errno.h>
+#include <pj/string.h>
+#include <pj/os.h>
 #include <windows.h>
 #include <time.h>
@@ -29,8 +32,10 @@
 {
     HANDLE hFile;
+    PJ_DECL_UNICODE_TEMP_BUF(wfilename,256);
 
     PJ_ASSERT_RETURN(filename != NULL, 0);
 
-    hFile = CreateFile(filename, READ_CONTROL, FILE_SHARE_READ, NULL,
+    hFile = CreateFile(PJ_NATIVE_STRING(filename,wfilename), READ_CONTROL, 
+		       FILE_SHARE_READ, NULL,
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
     if (hFile == INVALID_HANDLE_VALUE)
@@ -50,8 +55,9 @@
     DWORD sizeLo, sizeHi;
     pj_off_t size;
+    PJ_DECL_UNICODE_TEMP_BUF(wfilename,256);
 
     PJ_ASSERT_RETURN(filename != NULL, -1);
 
-    hFile = CreateFile(filename, READ_CONTROL, 
+    hFile = CreateFile(PJ_NATIVE_STRING(filename, wfilename), READ_CONTROL, 
                        FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
@@ -81,7 +87,9 @@
 PJ_DEF(pj_status_t) pj_file_delete(const char *filename)
 {
+    PJ_DECL_UNICODE_TEMP_BUF(wfilename,256);
+
     PJ_ASSERT_RETURN(filename != NULL, PJ_EINVAL);
 
-    if (DeleteFile(filename) == FALSE)
+    if (DeleteFile(PJ_NATIVE_STRING(filename,wfilename)) == FALSE)
         return PJ_RETURN_OS_ERROR(GetLastError());
 
@@ -96,12 +104,16 @@
 {
     BOOL rc;
+    PJ_DECL_UNICODE_TEMP_BUF(woldname,256);
+    PJ_DECL_UNICODE_TEMP_BUF(wnewname,256);
 
     PJ_ASSERT_RETURN(oldname!=NULL && newname!=NULL, PJ_EINVAL);
 
 #if PJ_WIN32_WINNT >= 0x0400
-    rc = MoveFileEx(oldname, newname, 
+    rc = MoveFileEx(PJ_NATIVE_STRING(oldname,woldname), 
+		    PJ_NATIVE_STRING(newname,wnewname), 
                     MOVEFILE_COPY_ALLOWED|MOVEFILE_REPLACE_EXISTING);
 #else
-    rc = MoveFile(oldname, newname);
+    rc = MoveFile(PJ_NATIVE_STRING(oldname, woldname), 
+		  PJ_NATIVE_STRING(newname, wnewname));
 #endif
 
@@ -116,29 +128,29 @@
                                          pj_time_val *time_val)
 {
-    SYSTEMTIME systemTime, localTime;
-    struct tm tm;
-
-    if (!FileTimeToSystemTime(file_time, &systemTime))
-        return -1;
-
-    if (!SystemTimeToTzSpecificLocalTime(NULL, &systemTime, &localTime))
-        return -1;
-
-    memset(&tm, 0, sizeof(struct tm));
-    tm.tm_year = localTime.wYear - 1900;
-    tm.tm_mon = localTime.wMonth - 1;
-    tm.tm_mday = localTime.wDay;
-    tm.tm_hour = localTime.wHour;
-    tm.tm_min = localTime.wMinute;
-    tm.tm_sec = localTime.wSecond;
-    tm.tm_isdst = 0;
-
-    time_val->sec = mktime(&tm);
-    if (time_val->sec == (time_t)-1)
-        return -1;
-
-    time_val->msec = localTime.wMilliseconds;
-
-    return PJ_SUCCESS;
+    FILETIME local_file_time;
+    SYSTEMTIME localTime;
+    pj_parsed_time pt;
+
+    if (!FileTimeToLocalFileTime(file_time, &local_file_time))
+	return PJ_RETURN_OS_ERROR(GetLastError());
+
+    if (!FileTimeToSystemTime(file_time, &localTime))
+        return PJ_RETURN_OS_ERROR(GetLastError());
+
+    //if (!SystemTimeToTzSpecificLocalTime(NULL, &systemTime, &localTime))
+    //    return PJ_RETURN_OS_ERROR(GetLastError());
+
+    pj_memset(&pt, 0, sizeof(pt));
+    pt.year = localTime.wYear;
+    pt.mon = localTime.wMonth-1;
+    pt.day = localTime.wDay;
+    pt.wday = localTime.wDayOfWeek;
+
+    pt.hour = localTime.wHour;
+    pt.min = localTime.wMinute;
+    pt.sec = localTime.wSecond;
+    pt.msec = localTime.wMilliseconds;
+
+    return pj_time_encode(&pt, time_val);
 }
 
@@ -151,8 +163,10 @@
     DWORD sizeLo, sizeHi;
     FILETIME creationTime, accessTime, writeTime;
+    PJ_DECL_UNICODE_TEMP_BUF(wfilename,256);
 
     PJ_ASSERT_RETURN(filename!=NULL && stat!=NULL, PJ_EINVAL);
 
-    hFile = CreateFile(filename, READ_CONTROL, FILE_SHARE_READ, NULL,
+    hFile = CreateFile(PJ_NATIVE_STRING(filename,wfilename), READ_CONTROL, 
+		       FILE_SHARE_READ, NULL,
                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
     if (hFile == INVALID_HANDLE_VALUE)
Index: pjproject/trunk/pjlib/src/pj/file_io_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/file_io_win32.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/file_io_win32.c	(revision 125)
@@ -18,4 +18,5 @@
  */
 #include <pj/file_io.h>
+#include <pj/compat/unicode.h>
 #include <pj/errno.h>
 #include <pj/assert.h>
@@ -44,4 +45,5 @@
                                   pj_oshandle_t *fd)
 {
+    PJ_DECL_UNICODE_TEMP_BUF(wpathname,256);
     HANDLE hFile;
     DWORD dwDesiredAccess = 0;
@@ -77,5 +79,6 @@
     dwFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL;
 
-    hFile = CreateFile(pathname, dwDesiredAccess, dwShareMode, NULL,
+    hFile = CreateFile(PJ_NATIVE_STRING(pathname,wpathname), 
+		       dwDesiredAccess, dwShareMode, NULL,
                        dwCreationDisposition, dwFlagsAndAttributes, NULL);
     if (hFile == INVALID_HANDLE_VALUE) {
Index: pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 125)
@@ -216,10 +216,12 @@
 	 * of suggestions from Douglas C. Schmidt and Ken Keys.
 	 */
-	int gp_rc;
-	struct sockaddr_in addr;
-	socklen_t addrlen = sizeof(addr);
-
-	gp_rc = getpeername(h->fd, (struct sockaddr*)&addr, &addrlen);
-	bytes_transfered = gp_rc;
+	{
+	    int gp_rc;
+	    struct sockaddr_in addr;
+	    socklen_t addrlen = sizeof(addr);
+
+	    gp_rc = getpeername(h->fd, (struct sockaddr*)&addr, &addrlen);
+	    bytes_transfered = gp_rc;
+	}
 #endif
 
@@ -400,5 +402,6 @@
              * that error is easier to catch.
              */
-#	    if defined(PJ_WIN32) && PJ_WIN32 != 0
+#	    if defined(PJ_WIN32) && PJ_WIN32 != 0 || \
+	       defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE != 0
                 rc = pj_sock_recv(h->fd, read_op->buf, &bytes_read, 0);
                 //rc = ReadFile((HANDLE)h->fd, read_op->buf, read_op->size,
Index: pjproject/trunk/pjlib/src/pj/ioqueue_select.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 125)
@@ -222,5 +222,6 @@
     /* Set socket to nonblocking. */
     value = 1;
-#ifdef PJ_WIN32
+#if defined(PJ_WIN32) && PJ_WIN32!=0 || \
+    defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
     if (ioctlsocket(sock, FIONBIO, (u_long*)&value)) {
 #else
Index: pjproject/trunk/pjlib/src/pj/log.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/log.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/log.c	(revision 125)
@@ -139,5 +139,8 @@
     /* Print the whole message to the string log_buffer. */
     len = len + vsnprintf(pre, sizeof(log_buffer)-len, format, marker);
-    if (len > 0 && len < sizeof(log_buffer)-1) {
+    if (len > 0 && len < sizeof(log_buffer)-2) {
+	if (log_decor & PJ_LOG_HAS_CR) {
+	    log_buffer[len++] = '\r';
+	}
 	if (log_decor & PJ_LOG_HAS_NEWLINE) {
 	    log_buffer[len++] = '\n';
@@ -146,4 +149,7 @@
     } else {
 	len = sizeof(log_buffer)-1;
+	if (log_decor & PJ_LOG_HAS_CR) {
+	    log_buffer[sizeof(log_buffer)-3] = '\r';
+	}
 	if (log_decor & PJ_LOG_HAS_NEWLINE) {
 	    log_buffer[sizeof(log_buffer)-2] = '\n';
Index: pjproject/trunk/pjlib/src/pj/os_core_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 125)
@@ -537,5 +537,5 @@
     return InterlockedIncrement(&atomic_var->value);
 #else
-#   error Fix Me
+    return InterlockedIncrement(&atomic_var->value);
 #endif
 }
@@ -559,5 +559,5 @@
     return InterlockedDecrement(&atomic_var->value);
 #else
-#   error Fix me
+    return InterlockedDecrement(&atomic_var->value);
 #endif
 }
@@ -580,5 +580,5 @@
     InterlockedExchangeAdd( &atomic_var->value, value );
 #else
-#   error Fix me
+    InterlockedExchangeAdd( &atomic_var->value, value );
 #endif
 }
@@ -594,5 +594,6 @@
     return oldValue + value;
 #else
-#   error Fix me
+    long oldValue = InterlockedExchangeAdd( &atomic_var->value, value);
+    return oldValue + value;
 #endif
 }
Index: pjproject/trunk/pjlib/src/pj/os_time_ansi.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_time_ansi.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/os_time_ansi.c	(revision 125)
@@ -49,5 +49,4 @@
     pt->sec = local_time->tm_sec;
     pt->wday = local_time->tm_wday;
-    pt->yday = local_time->tm_yday;
     pt->msec = tv->msec;
 
@@ -58,5 +57,21 @@
  * Encode parsed time to time value.
  */
-PJ_DEF(pj_status_t) pj_time_encode(const pj_parsed_time *pt, pj_time_val *tv);
+PJ_DEF(pj_status_t) pj_time_encode(const pj_parsed_time *pt, pj_time_val *tv)
+{
+    struct tm local_time;
+
+    local_time.tm_year = pt->year-1900;
+    local_time.tm_mon = pt->mon;
+    local_time.tm_mday = pt->day;
+    local_time.tm_hour = pt->hour;
+    local_time.tm_min = pt->min;
+    local_time.tm_sec = pt->sec;
+    local_time.tm_isdst = 0;
+    
+    tv->sec = mktime(&local_time);
+    tv->msec = pt->msec;
+
+    return PJ_SUCCESS;
+}
 
 /**
Index: pjproject/trunk/pjlib/src/pj/os_time_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_time_win32.c	(revision 125)
+++ pjproject/trunk/pjlib/src/pj/os_time_win32.c	(revision 125)
@@ -0,0 +1,137 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pj/os.h>
+#include <pj/string.h>
+#include <windows.h>
+
+///////////////////////////////////////////////////////////////////////////////
+
+#define SECS_TO_FT_MULT 10000000
+
+static LARGE_INTEGER base_time;
+
+// Find 1st Jan 1970 as a FILETIME 
+static void get_base_time(void)
+{
+    SYSTEMTIME st;
+    FILETIME ft;
+
+    memset(&st,0,sizeof(st));
+    st.wYear=1970;
+    st.wMonth=1;
+    st.wDay=1;
+    SystemTimeToFileTime(&st, &ft);
+    
+    base_time.LowPart = ft.dwLowDateTime;
+    base_time.HighPart = ft.dwHighDateTime;
+    base_time.QuadPart /= SECS_TO_FT_MULT;
+}
+
+PJ_DEF(pj_status_t) pj_gettimeofday(pj_time_val *tv)
+{
+    SYSTEMTIME st;
+    FILETIME ft;
+    LARGE_INTEGER li;
+
+    if (base_time.QuadPart == 0)
+	get_base_time();
+
+    GetLocalTime(&st);
+    SystemTimeToFileTime(&st, &ft);
+
+    li.LowPart = ft.dwLowDateTime;
+    li.HighPart = ft.dwHighDateTime;
+    li.QuadPart /= SECS_TO_FT_MULT;
+    li.QuadPart -= base_time.QuadPart;
+
+    tv->sec = li.LowPart;
+    tv->msec = st.wMilliseconds;
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pj_status_t) pj_time_decode(const pj_time_val *tv, pj_parsed_time *pt)
+{
+    LARGE_INTEGER li;
+    FILETIME ft;
+    SYSTEMTIME st;
+
+    li.QuadPart = tv->sec;
+    li.QuadPart += base_time.QuadPart;
+    li.QuadPart *= SECS_TO_FT_MULT;
+
+    ft.dwLowDateTime = li.LowPart;
+    ft.dwHighDateTime = li.HighPart;
+    FileTimeToSystemTime(&ft, &st);
+
+    pt->year = st.wYear;
+    pt->mon = st.wMonth-1;
+    pt->day = st.wDay;
+    pt->wday = st.wDayOfWeek;
+
+    pt->hour = st.wHour;
+    pt->min = st.wMinute;
+    pt->sec = st.wSecond;
+    pt->msec = tv->msec;
+
+    return PJ_SUCCESS;
+}
+
+/**
+ * Encode parsed time to time value.
+ */
+PJ_DEF(pj_status_t) pj_time_encode(const pj_parsed_time *pt, pj_time_val *tv)
+{
+    SYSTEMTIME st;
+    FILETIME ft;
+    LARGE_INTEGER li;
+
+    pj_memset(&st, 0, sizeof(st));
+    st.wYear = pt->year;
+    st.wMonth = pt->mon + 1;
+    st.wDay = pt->day;
+    st.wHour = pt->hour;
+    st.wMinute = pt->min;
+    st.wSecond = pt->sec;
+    st.wMilliseconds = pt->msec;
+    
+    SystemTimeToFileTime(&st, &ft);
+
+    li.LowPart = ft.dwLowDateTime;
+    li.HighPart = ft.dwHighDateTime;
+    li.QuadPart /= SECS_TO_FT_MULT;
+    li.QuadPart -= base_time.QuadPart;
+
+    tv->sec = li.LowPart;
+    tv->msec = st.wMilliseconds;
+
+    return PJ_SUCCESS;
+}
+
+/**
+ * Convert local time to GMT.
+ */
+PJ_DEF(pj_status_t) pj_time_local_to_gmt(pj_time_val *tv);
+
+/**
+ * Convert GMT to local time.
+ */
+PJ_DEF(pj_status_t) pj_time_gmt_to_local(pj_time_val *tv);
+
+
Index: pjproject/trunk/pjlib/src/pj/os_timestamp_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_timestamp_win32.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/os_timestamp_win32.c	(revision 125)
@@ -25,4 +25,5 @@
     defined(PJ_HAS_PENTIUM) && PJ_HAS_PENTIUM!=0 && \
     defined(_MSC_VER)
+
 /*
  * Use rdtsc to get the OS timestamp.
@@ -37,7 +38,14 @@
     DWORD size;
 
+#if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
+    rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
+		      L"HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0",
+		      0, 0, &key);
+#else
     rc = RegOpenKey( HKEY_LOCAL_MACHINE,
 		     "HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0",
 		     &key);
+#endif
+
     if (rc != ERROR_SUCCESS)
 	return PJ_RETURN_OS_ERROR(rc);
Index: pjproject/trunk/pjlib/src/pj/sock_bsd.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/sock_bsd.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pj/sock_bsd.c	(revision 125)
@@ -363,5 +363,6 @@
 
     PJ_CHECK_STACK();
-#if defined(PJ_WIN32) && PJ_WIN32==1
+#if defined(PJ_WIN32) && PJ_WIN32!=0 || \
+    defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
     rc = closesocket(sock);
 #else
Index: pjproject/trunk/pjlib/src/pjlib-test/main.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 125)
@@ -91,4 +91,7 @@
     }
 
+    pj_log_set_decor(PJ_LOG_HAS_NEWLINE | PJ_LOG_HAS_TIME | 
+                     PJ_LOG_HAS_MICRO_SEC);
+
     rc = test_main();
 
Index: pjproject/trunk/pjlib/src/pjlib-test/main_mod.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/main_mod.c	(revision 124)
+++ pjproject/trunk/pjlib/src/pjlib-test/main_mod.c	(revision 125)
@@ -25,4 +25,7 @@
     printk(KERN_INFO "PJLIB test module loaded. Starting tests...\n");
     
+    pj_log_set_decor(PJ_LOG_HAS_NEWLINE | PJ_LOG_HAS_TIME | 
+                     PJ_LOG_HAS_MICRO_SEC);
+
     test_main();
 
